diff --git a/cmd/zfs/zfs_main.c b/cmd/zfs/zfs_main.c
index b0094469390..0c88fb3f840 100644
--- a/cmd/zfs/zfs_main.c
+++ b/cmd/zfs/zfs_main.c
@@ -7045,6 +7045,7 @@ zfs_do_bookmark(int argc, char **argv)
 static struct json_object *
 get_stats(nvlist_t *outnvl)
 {
+	nvlist_t *cnv = NULL;
 	nvpair_t *elem = NULL;
 	uint64_t val;
 	char *str_val;
@@ -7063,6 +7064,13 @@ get_stats(nvlist_t *outnvl)
 				json_object_object_add(jobj, nvpair_name(elem),
 				    json_object_new_string(str_val));
 				break;
+			case DATA_TYPE_NVLIST:
+				(void) nvpair_value_nvlist(elem, &cnv);
+				struct json_object *obj = get_stats(cnv);
+				if (obj)
+					json_object_object_add(jobj,
+					    nvpair_name(elem), obj);
+				break;
 			default:
 				fprintf(stderr, "nvpair type : %d name:%s\n",
 				    nvpair_type(elem), nvpair_name(elem));
@@ -7086,6 +7094,7 @@ zfs_do_stats(int argc, char **argv)
 		usage(B_FALSE);
 		return (-1);
 	}
+
 	if ((error = lzc_stats(argv[1], NULL, &outnvl)) != 0) {
 		fprintf(stderr, "failed stats command for %s with err %d\n",
 		    argv[1], error);
diff --git a/include/sys/spa_impl.h b/include/sys/spa_impl.h
index b1e78c1d592..9cfd23cc27c 100644
--- a/include/sys/spa_impl.h
+++ b/include/sys/spa_impl.h
@@ -125,6 +125,25 @@ typedef enum spa_all_vdev_zap_action {
 	AVZ_ACTION_INITIALIZE
 } spa_avz_action_t;
 
+#define	KB 1024
+#define	ZFS_HISTOGRAM_IO_SIZE (1024 * KB)
+#define	ZFS_HISTOGRAM_IO_BLOCK (32 * KB)
+
+#define	zfs_histogram_add(_array, _bucket, _size, _latency) \
+    atomic_inc_64(&(_array[_bucket / ZFS_HISTOGRAM_IO_BLOCK].count)); \
+    atomic_add_64(&(_array[_bucket / ZFS_HISTOGRAM_IO_BLOCK].size), _size); \
+    atomic_add_64(&(_array[_bucket / ZFS_HISTOGRAM_IO_BLOCK].latency), _latency)
+
+#define	zio_histogram_add(_array, _bucket, _size) \
+    atomic_inc_64(&(_array[_bucket / ZFS_HISTOGRAM_IO_BLOCK].count)); \
+    atomic_add_64(&(_array[_bucket / ZFS_HISTOGRAM_IO_BLOCK].size), _size);
+
+typedef struct zfs_histogram {
+	uint64_t size;
+	uint64_t count;
+	uint64_t latency;
+} zfs_histogram_t;
+
 struct spa {
 	/*
 	 * Fields protected by spa_namespace_lock.
@@ -289,6 +308,10 @@ struct spa {
 	refcount_t	spa_refcount;		/* number of opens */
 
 	taskq_t		*spa_upgrade_taskq;	/* taskq for upgrade jobs */
+	zfs_histogram_t zfs_rio_histogram[ZFS_HISTOGRAM_IO_SIZE /
+	    ZFS_HISTOGRAM_IO_BLOCK + 1];
+	zfs_histogram_t zfs_wio_histogram[ZFS_HISTOGRAM_IO_SIZE /
+	    ZFS_HISTOGRAM_IO_BLOCK + 1];
 };
 
 extern char *spa_config_path;
diff --git a/include/zrepl_mgmt.h b/include/zrepl_mgmt.h
index b8a86faa061..6e3b701065f 100644
--- a/include/zrepl_mgmt.h
+++ b/include/zrepl_mgmt.h
@@ -31,6 +31,7 @@
 #include <uzfs_io.h>
 #include "zrepl_prot.h"
 #include <sys/zfs_context.h>
+#include <sys/spa_impl.h>
 
 #ifdef	__cplusplus
 extern "C" {
@@ -196,6 +197,12 @@ typedef struct zvol_info_s {
 	uint64_t 	write_byte;
 	uint64_t	sync_req_ack_cnt;
 	uint64_t 	sync_latency;
+
+	// histogram of IOs
+	zfs_histogram_t uzfs_rio_histogram[ZFS_HISTOGRAM_IO_SIZE /
+	    ZFS_HISTOGRAM_IO_BLOCK + 1];
+	zfs_histogram_t uzfs_wio_histogram[ZFS_HISTOGRAM_IO_SIZE /
+	    ZFS_HISTOGRAM_IO_BLOCK + 1];
 } zvol_info_t;
 
 typedef struct thread_args_s {
diff --git a/lib/libzrepl/data_conn.c b/lib/libzrepl/data_conn.c
index fcb65c687e5..e2881155e5b 100644
--- a/lib/libzrepl/data_conn.c
+++ b/lib/libzrepl/data_conn.c
@@ -377,6 +377,7 @@ uzfs_zvol_worker(void *arg)
 			    (char *)zio_cmd->buf,
 			    hdr->offset, hdr->len,
 			    metadata_desc);
+
 			atomic_inc_64(&zinfo->read_req_received_cnt);
 			break;
 
@@ -1703,6 +1704,7 @@ uzfs_zvol_io_ack_sender(void *arg)
 	zvol_info_t		*zinfo;
 	thread_args_t 		*thrd_arg;
 	zvol_io_cmd_t 		*zio_cmd = NULL;
+	uint64_t len, latency;
 
 	thrd_arg = (thread_args_t *)arg;
 	fd = thrd_arg->fd;
@@ -1798,17 +1800,38 @@ uzfs_zvol_io_ack_sender(void *arg)
 					}
 				}
 			}
+			latency = gethrtime() - zio_cmd->io_start_time;
 			atomic_inc_64(&zinfo->read_req_ack_cnt);
 			atomic_add_64(&zinfo->read_byte, zio_cmd->hdr.len);
-			atomic_add_64(&zinfo->read_latency,
-			    gethrtime() - zio_cmd->io_start_time);
+			atomic_add_64(&zinfo->read_latency, latency);
+
+			len = zio_cmd->hdr.len;
+			if (len < ZFS_HISTOGRAM_IO_SIZE) {
+				zfs_histogram_add(zinfo->uzfs_rio_histogram,
+				    len, len, latency);
+			} else {
+				zfs_histogram_add(zinfo->uzfs_rio_histogram,
+				    ZFS_HISTOGRAM_IO_SIZE, len, latency);
+			}
 		} else {
 			if (zio_cmd->hdr.opcode == ZVOL_OPCODE_WRITE) {
+				latency = gethrtime() - zio_cmd->io_start_time;
 				atomic_inc_64(&zinfo->write_req_ack_cnt);
 				atomic_add_64(&zinfo->write_byte,
 				    zio_cmd->hdr.len);
-				atomic_add_64(&zinfo->write_latency,
-				    gethrtime() - zio_cmd->io_start_time);
+				atomic_add_64(&zinfo->write_latency, latency);
+
+				len = zio_cmd->hdr.len;
+				if (len < ZFS_HISTOGRAM_IO_SIZE) {
+					zfs_histogram_add(zinfo->
+					    uzfs_wio_histogram, len,
+					    len, latency);
+				} else {
+					zfs_histogram_add(zinfo->
+					    uzfs_wio_histogram,
+					    ZFS_HISTOGRAM_IO_SIZE,
+					    len, latency);
+				}
 			} else if (zio_cmd->hdr.opcode == ZVOL_OPCODE_SYNC) {
 				atomic_inc_64(&zinfo->sync_req_ack_cnt);
 				atomic_add_64(&zinfo->sync_latency,
diff --git a/module/zfs/vdev.c b/module/zfs/vdev.c
index acac2a97374..aa0b691533d 100644
--- a/module/zfs/vdev.c
+++ b/module/zfs/vdev.c
@@ -3151,6 +3151,32 @@ vdev_stat_update(zio_t *zio, uint64_t psize)
 			vs->vs_ops[type]++;
 			vs->vs_bytes[type] += psize;
 
+#if !defined(_KERNEL)
+			if (type == ZIO_TYPE_READ) {
+				if (psize < ZFS_HISTOGRAM_IO_SIZE) {
+					zio_histogram_add(spa->
+					    zfs_rio_histogram,
+					    psize, psize);
+				} else {
+					zio_histogram_add(spa->
+					    zfs_rio_histogram,
+					    ZFS_HISTOGRAM_IO_SIZE, psize);
+				}
+			}
+
+			if (type == ZIO_TYPE_WRITE) {
+				if (psize < ZFS_HISTOGRAM_IO_SIZE) {
+					zio_histogram_add(spa->
+					    zfs_wio_histogram,
+					    psize, psize);
+				} else {
+					zio_histogram_add(spa->
+					    zfs_wio_histogram,
+					    ZFS_HISTOGRAM_IO_SIZE, psize);
+				}
+			}
+#endif
+
 			if (flags & ZIO_FLAG_DELEGATED) {
 				vsx->vsx_agg_histo[zio->io_priority]
 				    [RQ_HISTO(zio->io_size)]++;
diff --git a/module/zfs/zvol.c b/module/zfs/zvol.c
index a969ca49ba2..dc93662a711 100644
--- a/module/zfs/zvol.c
+++ b/module/zfs/zvol.c
@@ -96,6 +96,7 @@
 #include <uzfs_mgmt.h>
 #include <sys/uzfs_zvol.h>
 #include <zrepl_mgmt.h>
+
 #endif
 
 unsigned int zvol_inhibit_dev = 0;
@@ -351,6 +352,12 @@ int
 uzfs_ioc_stats(zfs_cmd_t *zc, nvlist_t *nvl)
 {
 	zvol_info_t *zv = NULL;
+	int i;
+	uint64_t len;
+	char key[256], val[256];
+
+	len = ZFS_HISTOGRAM_IO_SIZE /
+	    ZFS_HISTOGRAM_IO_BLOCK;
 
 	(void) mutex_enter(&zvol_list_mutex);
 	SLIST_FOREACH(zv, &zvol_list, zinfo_next) {
@@ -410,14 +417,93 @@ uzfs_ioc_stats(zfs_cmd_t *zc, nvlist_t *nvl)
 			fnvlist_add_uint64(innvl, "syncLatency",
 			    zv->sync_latency);
 
+			nvlist_t *rnvl = fnvlist_alloc();
+
+			for (i = 0; i <= len; i++) {
+				if (zv->uzfs_rio_histogram[i].count) {
+					sprintf(key, "%uKB", (i + 1) *
+					    ZFS_HISTOGRAM_IO_BLOCK / KB);
+					sprintf(val, "%lu/%lu/%lu",
+					    zv->uzfs_rio_histogram[i].size,
+					    zv->uzfs_rio_histogram[i].count,
+					    zv->uzfs_rio_histogram[i].latency);
+					fnvlist_add_string(rnvl, key, val);
+				}
+			}
+			fnvlist_add_nvlist(innvl, "ruio", rnvl);
+			fnvlist_free(rnvl);
+
+			nvlist_t *wnvl = fnvlist_alloc();
+
+			for (i = 0; i <= len; i++) {
+				if (zv->uzfs_wio_histogram[i].count) {
+					sprintf(key, "%uKB", (i + 1) *
+					    ZFS_HISTOGRAM_IO_BLOCK / KB);
+					sprintf(val, "%lu/%lu/%lu",
+					    zv->uzfs_wio_histogram[i].size,
+					    zv->uzfs_wio_histogram[i].count,
+					    zv->uzfs_wio_histogram[i].latency);
+					fnvlist_add_string(wnvl, key, val);
+				}
+			}
+
+			fnvlist_add_nvlist(innvl, "wuio", wnvl);
+			fnvlist_free(wnvl);
+
 			fnvlist_add_nvlist(nvl, zv->name, innvl);
 			fnvlist_free(innvl);
+
 			if (zc->zc_name[0] != '\0')
 				break;
 		}
 	}
 	(void) mutex_exit(&zvol_list_mutex);
 
+	if (zc->zc_name[0] == '\0') {
+		spa_t *spa = NULL;
+		nvlist_t *tnvl = fnvlist_alloc();
+		mutex_enter(&spa_namespace_lock);
+		while ((spa = spa_next(spa)) != NULL) {
+			nvlist_t *pnvl = fnvlist_alloc();
+
+			nvlist_t *innvl = fnvlist_alloc();
+			for (i = 0; i <= len; i++) {
+				if (spa->zfs_rio_histogram[i].count) {
+					sprintf(key, "%uKB", (i + 1) *
+					    ZFS_HISTOGRAM_IO_BLOCK / KB);
+					sprintf(val, "%lu/%lu",
+					    spa->zfs_rio_histogram[i].size,
+					    spa->zfs_rio_histogram[i].count);
+					fnvlist_add_string(innvl, key, val);
+				}
+			}
+			fnvlist_add_nvlist(pnvl, "rzio", innvl);
+			fnvlist_free(innvl);
+
+			innvl = fnvlist_alloc();
+			for (i = 0; i <= len; i++) {
+				if (spa->zfs_wio_histogram[i].count) {
+					sprintf(key, "%uKB", (i + 1) *
+					    ZFS_HISTOGRAM_IO_BLOCK / KB);
+					sprintf(val, "%lu/%lu",
+					    spa->zfs_wio_histogram[i].size,
+					    spa->zfs_wio_histogram[i].count);
+					fnvlist_add_string(innvl, key, val);
+				}
+			}
+			fnvlist_add_nvlist(pnvl, "wzio", innvl);
+			fnvlist_add_nvlist(tnvl, spa->spa_name, pnvl);
+			fnvlist_free(innvl);
+			fnvlist_free(pnvl);
+		}
+		nvlist_t *onvl = fnvlist_alloc();
+		fnvlist_add_nvlist(onvl, "pool", tnvl);
+		fnvlist_free(tnvl);
+		fnvlist_add_nvlist(nvl, "pool", onvl);
+		fnvlist_free(onvl);
+
+		mutex_exit(&spa_namespace_lock);
+	}
 	return (0);
 }
 #endif
